//
//  MegaTableView.h
//  MegaTableView
//
//  Created by CHENG POWEN on 13/3/11.
//  Copyright (c) 2013年 CHENG POWEN. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>
#import "UIView+AddLine.h"

@protocol MegaTableViewDataSource;

@interface MegaTableView : UIView<UITableViewDataSource,UITableViewDelegate>{
    
    BOOL respondsToWidthOfHeader;
    BOOL respondsToTitleBGColorInMegaTableView;
    BOOL respondsToSectionBGColorInMegaTableView;
    BOOL respondsToCellBGColorInMegaTableView;
    BOOL respondsToHeaderBGColorInMegaTableView;
    BOOL respondsToTitleTextColorInMegaTableView;
    BOOL respondsToSectionTextColorInMegaTableView;
    BOOL respondsToCellTextColorInMegaTableView;
    BOOL respondsToHeaderTextColorInMegaTableView;
    BOOL respondsToTitleFontInMegaTableView;
    BOOL respondsToSectionFontInMegaTableView;
    BOOL respondsToCellFontInMegaTableView;
    BOOL respondsToHeaderFontInMegaTableView;
    BOOL respondsToTableLineColorInMegaTableView;
    BOOL respondsToTableLineWidthInMegaTableView;
    BOOL respondsToSetSectionInMegaTableView;
    BOOL respondsToSectionStructInMegatableView;
    BOOL respondsToSelectionColorInMegatableView;
    
    NSMutableArray *_rowsInColumnsInContent;
    NSMutableArray *_columnsInRowsInContent;
    NSMutableArray *_rowsInColumnsInHeader;
    NSMutableArray *_columnsInRowsInHeader;
    NSMutableArray *_titleInContent;
    NSMutableArray *_titleInHeader;
    
    NSMutableArray *_colWidthForContent;
    NSMutableArray *_colWidthForHeader;
    
    int _sectionStartRow;
    int _sectionStep;
    
    UIColor *_defaultBGColor;
    UIColor *_defaultTextColor;
    UIColor *_defaultLineColor;
    UIColor *_defaultselectionColor;
    UIFont *_defaultFont;
    CGFloat _defaultHeight;
    CGFloat _defaultLineWidth;
    
    UIColor *_cellBGColor;
    UIColor *_titleBGColor;
    UIColor *_sectionBGColor;
    UIColor *_headerBGColor;
    UIColor *_selectionColor;
    
    UIColor *_cellTextColor;
    UIColor *_titleTextColor;
    UIColor *_sectionTextColor;
    UIColor *_headerTextColor;
    
    UIFont *_cellFont;
    UIFont *_titleFont;
    UIFont *_sectionFont;
    UIFont *_headerFont;
    
    UIColor *_lineColr;
    CGFloat _lineWidth;
}

@property (weak, nonatomic) id<MegaTableViewDataSource>dataSource;
@property (strong, nonatomic) UITableView *contentTableView;
@property (strong, nonatomic) UITableView *headerTableView;
@property (strong, nonatomic) UIScrollView *sclView;

- (void)reloadMegaTable;

@end

@protocol MegaTableViewDataSource <NSObject>

@required
- (NSUInteger)numberOfColumnsOfHeaderInMegaTableView:(UIView *)megaTableView;
- (NSUInteger)numberOfColumnsOfContentInMegaTableView:(UIView *)megaTableView;
//- (NSUInteger)numberOfSectionInMegaTableView:(UIView *)megaTableView;
- (NSUInteger)numberOfRowsInMegaTableView:(UIView *)megaTableView;
- (NSString *)megaTableView:(UIView *)megaTableView titleInContentAtColumn:(int)column;
- (NSString *)megaTableView:(UIView *)megaTableView cellInContentAtRow:(int)row column:(int)column;
- (NSString *)megaTableView:(UIView *)megaTableView titleInHeaderAtColumn:(int)column;
- (NSString *)megaTableView:(UIView *)megaTableView cellInHeaderAtRow:(int)row column:(int)column;

@optional
- (CGFloat)widthOfHeaderInMegaTableView:(UIView *)megaTableView;

- (UIColor *)titleBGColorInMegaTableView:(UIView *)megaTableView;
- (UIColor *)titleTextColorInMegaTableView:(UIView *)megaTableView;
- (UIFont *)titleFontInMegaTableView:(UIView *)megaTableView;

- (UIColor *)sectionBGColorInMegaTableView:(UIView *)megaTableView;
- (UIColor *)sectionTextColorInMegaTableView:(UIView *)megaTableView;
- (UIFont *)sectionFontInMegaTableView:(UIView *)megaTableView;

- (UIColor *)cellBGColorInMegaTableView:(UIView *)megaTableView;
- (UIColor *)cellTextColorInMegaTableView:(UIView *)megaTableView;
- (UIFont *)cellFontInMegaTableView:(UIView *)megaTableView;

- (UIColor *)headerBGColorInMegatableView:(UIView *)megaTableView;
- (UIColor *)headerTextColorInMegatableView:(UIView *)megaTableView;
- (UIFont *)headerFontInMegaTableView:(UIView *)megaTableView;

- (UIColor *)tableLineColorInMegatableView:(UIView *)megaTableView;
- (CGFloat)tableLineWidthInMegatableView:(UIView *)megaTableView;

- (NSArray *)sectionStructInMegatableView:(UIView *)megaTableView;

- (UIColor *)selectionColorInMegatableView:(UIView *)megaTableView;

@end