//
//  DemoViewController.m
//  MegaTableView
//
//  Created by CHENG POWEN on 13/3/11.
//  Copyright (c) 2013年 CHENG POWEN. All rights reserved.
//

#import "DemoViewController.h"

@interface DemoViewController (){
    int numbersOfRow;
    int numbersOfColumn;
    MegaTableView *tableView;
}

@end

@implementation DemoViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    numbersOfColumn = 8;
    numbersOfRow = 100;
    tableView = [[MegaTableView alloc]initWithFrame:CGRectMake(50, 50, 700, 800)];
    [tableView setDataSource:self];
    [self.view addSubview:tableView];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (NSUInteger)numberOfColumnsOfContentInMegaTableView:(UIView *)megaTableView{
    return numbersOfColumn;
}

- (NSUInteger)numberOfColumnsOfHeaderInMegaTableView:(UIView *)megaTableView{
    return 2;
}

- (NSUInteger)numberOfRowsInMegaTableView:(UIView *)megaTableView{
    return numbersOfRow;
}

- (NSString *)megaTableView:(UIView *)megaTableView cellInContentAtRow:(int)row column:(int)column{
//    if (row>20 && column<3) {
//        return @"nil";
//    }else {
//        return [NSString stringWithFormat:@"row:%d column:%d",row,column];
//    }
    return [NSString stringWithFormat:@"row:%d column:%d",row,column];
}

- (NSString *)megaTableView:(UIView *)megaTableView cellInHeaderAtRow:(int)row column:(int)column{
    return [NSString stringWithFormat:@"row:%d column:%d",row,column];
}

- (NSString *)megaTableView:(UIView *)megaTableView titleInContentAtColumn:(int)column{
    return [NSString stringWithFormat:@"content col:%d",column];
}

- (NSString *)megaTableView:(UIView *)megaTableView titleInHeaderAtColumn:(int)column{
    return [NSString stringWithFormat:@"header col:%d",column];
}
//optional
- (UIColor *)cellBGColorInMegaTableView:(UIView *)megaTableView{
    return [UIColor colorWithRed:(196/255.0) green:(245/255.0) blue:(255/255.0) alpha:1.0];
}

- (UIColor *)sectionBGColorInMegaTableView:(UIView *)megaTableView{
    return [UIColor greenColor];
}

- (UIColor *)headerBGColorInMegatableView:(UIView *)megaTableView{
    return [UIColor grayColor];
}

- (UIColor *)titleBGColorInMegaTableView:(UIView *)megaTableView{
    return [UIColor orangeColor];
}

- (UIFont *)titleFontInMegaTableView:(UIView *)megaTableView{
    return [UIFont fontWithName:@"Helvetica" size:24.0f];
}

- (UIFont *)cellFontInMegaTableView:(UIView *)megaTableView{
    return [UIFont fontWithName:@"Helvetica" size:16.0f];
}

- (UIFont *)sectionFontInMegaTableView:(UIView *)megaTableView{
    return [UIFont fontWithName:@"Helvetica" size:20.0f];
}

- (UIFont *)headerFontInMegaTableView:(UIView *)megaTableView{
    return [UIFont fontWithName:@"Helvetica" size:28.0f];
}

- (UIColor *)cellTextColorInMegaTableView:(UIView *)megaTableView{
    return [UIColor blackColor];
}

- (UIColor *)tableLineColorInMegatableView:(UIView *)megaTableView{
    return [UIColor blackColor];
}

- (UIColor *)selectionColorInMegatableView:(UIView *)megaTableView{
    return [UIColor groupTableViewBackgroundColor];
}

- (CGFloat)tableLineWidthInMegatableView:(UIView *)megaTableView{
    return 2.0f;
}

- (NSArray *)sectionStructInMegatableView:(UIView *)megaTableView{
    NSMutableArray *array = [[NSMutableArray alloc]initWithCapacity:2];
    [array addObject:[NSNumber numberWithInt:9999]];//start row of section
    [array addObject:[NSNumber numberWithInt:5]];//step in rows
    return [[NSArray alloc]initWithArray:array];
}
- (IBAction)reloadBtn:(id)sender {
    numbersOfRow = 10;
    numbersOfColumn = 3;
    [tableView reloadMegaTable];
}
@end
